#!/bin/bash
#
# Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
#
# NOTE: This script is not called by the graphic installation utility.
#

# Store the path to the script
SCRIPTPATH=`dirname $0`

USERNAME=`id -un`
if [ "$USERNAME" != "root" ] ; then
    echo " "
    echo "You must be root to run this script"
    exit 1
fi

# the common part of the preinstall (used by both this script and graphical).
# If the execution fails, don't run the rest of the preinstall.sh script
if ! $SCRIPTPATH/preinstall2.sh; then
	echo "Exiting from preinstall.sh..." >&2
	exit 1
fi

# Are we on an OpenUnix system?
OPENUNIX=0
if [ -e /unixware/etc/rc0.d/K02audit ]; then
	OPENUNIX=1
fi

if [ $OPENUNIX -eq 1 ]; then
	./lkp_master lkp_msg
	exit 0
fi

INITPATH="/etc/rc.d/init.d"

[ -f $INITPATH/postfix ] && $INITPATH/postfix stop >/dev/null 2>&1
[ -f $INITPATH/cyrus   ] && $INITPATH/cyrus   stop >/dev/null 2>&1
[ -f $INITPATH/ldap    ] && $INITPATH/ldap    stop >/dev/null 2>&1
[ -f $INITPATH/mta     ] && $INITPATH/mta     stop >/dev/null 2>&1
> $1
if rpm -q sendmail > /dev/null 2>&1; then
	# make sure sendmail is really, absolutely, positively, truely dead
	killall -9 sendmail
	rpm -e sendmail-cf >> $1 2>&1
	rpm -e sendmail-doc >> $1 2>&1
	rpm -e sendmail >> $1 2>&1
fi
if rpm -q imap-2000 > /dev/null 2>&1; then
	rpm -e imap-2000 >> $1 2>&1
	rpm -e imap-devel-2000 >> $1 2>&1
fi
# Upgrade php if its already installed
if rpm -q php-4.0.4pl1-3 > /dev/null 2>&1; then
	rpm -U --nodeps --force ../RPMS/php-4.0.4pl1-3crypt.i586.rpm 
fi

