#!/bin/bash

# this is the common preinstall script shared by both the
# volution and graphical install procedures.

# If we're installing on an OpenUnix system w/ LKP, make sure the
# Linux side has an /etc/resolv.conf file (it's not set up by default
# with the OpenUnix LKP installation).

if [ -e /unixware/etc/resolv.conf ]; then
        if grep ^nameserver /unixware/etc/resolv.conf > /dev/null 2>&1; then
                if [ -e /etc/resolv.conf ] && [ ! -L /etc/resolv.conf ]; then 
			mv /etc/resolv.conf /etc/resolv.conf.dist 
		fi
                ln -s /unixware/etc/resolv.conf /etc/resolv.conf
        fi
fi

# Check whether we have name resolution

if ! dig `hostname` > /dev/null 2>&1; then
        echo "There appears to be a problem with DNS." >&2
        exit 1
fi

SAVEDIR=/etc/opt/lsb-caldera.com-volution/msg/save
# save the ldap config for optional restore later
mkdir -p $SAVEDIR
cp /etc/ldap/ldap.conf $SAVEDIR
cp /etc/ldap/slapd.conf $SAVEDIR
cp /etc/pam_ldap/auth_ldap.conf $SAVEDIR
cp /etc/sysconfig/daemons/ldap $SAVEDIR

