%define _manprefix      %{_mandir}%{manEN}

#
# Cyrus SASL
#
Summary:	Cyrus SASL
Name:		cyrus-sasl
Version:	1.5.24
Release:	1
Copyright:	CMU public license
Group:		Applications
URL:		http://asg.web.cmu.edu/sasl/
Source:		ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/%{Name}-%{Version}.tar.gz
Distribution:	Caldera, Inc.
Vendor:		Caldera, Inc. 
Packager:	Scott Simmons <simmons@caldera.com>
BuildRoot: 	%{_tmppath}/%{Name}-%{Version}

%Description
SASL is the Simple Authentication and Security Layer, a method for adding
authentication support to connection-based protocols. To use SASL, a protocol
includes a command for identifying and authenticating a user to a server and
for optionally negotiating protection of subsequent protocol interactions. If
its use is negotiated, a security layer is inserted between the protocol and
the connection. 

%Prep
%setup

%Build
# for now, don't do anything except anonymous and plain auth
./configure \
	--prefix=/usr/cyrus-sasl \
	--libdir=/usr/cyrus-sasl/lib \
	--with-plugindir=/usr/cyrus-sasl/lib/sasl \
	--enable-plain=yes \
	--with-pam=yes \
	--with-pwcheck=yes \
	--enable-cram=no \
	--enable-scram=no \
	--enable-digest=no \
	--enable-krb4=no \
	--enable-gssapi=no \
	--with-des=no \
	--with-rc4=no \
	--mandir=%{_manprefix}
make

%Install
%{mkDESTDIR}

#%Post
#ln -s /usr/local/lib/sasl /usr/lib/sasl
#
#%postun
#rm -f /usr/lib/sasl

make DESTDIR=$DESTDIR install

%Clean
%{rmDESTDIR}

%Files
#/usr/local/include
#/usr/local/lib/*
#/usr/local/man/man3/*
#/usr/local/man/man8/*
#/usr/local/sbin/*
/usr/cyrus-sasl
