Name        	: db
Version     	: 3.3.11
Release     	: 0c
Group       	: System/Library

Summary     	: Berkeley DataBase file library.

Copyright   	: BSD
Packager    	: Torsten Duwe <duwe@caldera.de>

Conflicts       : glibc < 2.1.90

Source0:	http://www.sleepycat.com/update/%{Version}/db-%{Version}.tar.gz
Source1:	http://www.sleepycat.com/update/2.7.7/db-2.7.7.tar.gz
Source2:	http://www.sleepycat.com/update/1.85/db.1.85.tar.gz
Source3:	db-1.85-Versions
Source4:	db-2.7.7-Versions

#Patch0:	http://www.sleepycat.com/update/1.85/patch.185.html
Patch0:		patch.185
Patch1:		db1-glibc-fix
Patch2:		db2-ia64.patch
Patch3:         http://www.sleepycat.com/update/3.3.11/patch.3.3.11.1
Patch4:         http://www.sleepycat.com/update/3.3.11/patch.3.3.11.2

BuildRoot   	: /tmp/%{Name}-%{Version}

%Description
This package installs the Berkeley database, a C library and utilities
for creating and working with embedded databases.

%Prep
%setup -T -c -n %{Name}-%{Version} -a 0 -a 1 -a 2 
%patch0 -p0
%patch1 -p0
%patch2 -p1
cd %{Name}-%{Version}
%patch3 -p0
%patch4 -p0
cd ..
mkdir %{_arch}-linux{,-static}-{2,3}

# from glibc package
echo we are here
pwd
cp   %{SOURCE3} db-2.7.7/Versions
cp   %{SOURCE4} db.1.85/Versions 
(cd db-%{Version}/dist && libtoolize --copy --force)

%Build
cd db.1.85/PORT/linux/
make OORG="$RPM_OPT_FLAGS -fPIC"
gcc -shared -o libdb1.so.2.7.7 -Wl,-soname,libdb1.so.2 -Wl,--whole-archive libdb.a -Wl,--no-whole-archive

cd ../../../%{_arch}-linux-2

CFLAGS="$RPM_OPT_FLAGS -fPIC" ../db-2.7.7/dist/configure \
	--prefix=/usr --enable-compat185 --enable-dump185 %{_arch}-linux
make libdb.a
mv libdb.a libdb_pic.a
gcc -shared -o libdb.so.2.7.7 -Wl,-soname,libdb.so.2 \
	-Wl,--whole-archive libdb_pic.a -Wl,--no-whole-archive &&
	ln -sfn libdb.so.2.7.7 libdb.so
	/bin/echo -e "/* GNU ld script */\nGROUP ( libdb.so )" > libdb.a
make LIBS=./libdb.so.2.7.7	# rebuild programs dynamically

cd ../%{_arch}-linux-static-2
CFLAGS="$RPM_OPT_FLAGS" ../db-2.7.7/dist/configure \
	--prefix=/usr --enable-compat185 %{_arch}-linux
make libdb.a

cd ../%{_arch}-linux-3
CFLAGS="$RPM_OPT_FLAGS" ../db-%{Version}/dist/configure \
	--prefix=/usr --enable-compat185 --enable-shared \
        --enable-static --enable-rpc --enable-cxx
make

%Install
%{mkDESTDIR}

DD=$DESTDIR%{_defaultdocdir}/%{Name}-%{Version}
mkdir -p $DD

make -C %{_arch}-linux-2 install prefix=$DESTDIR/usr
mv $DESTDIR/usr/BerkeleyDB/* $DESTDIR/usr/
rmdir $DESTDIR/usr/BerkeleyDB
mkdir -p $DESTDIR/usr/include/db2
mv $DESTDIR/usr/include/*.h $DESTDIR/usr/include/db2
mv $DESTDIR/usr/docs $DD/db2
mkdir $DESTDIR/lib
cp -p %{_arch}-linux-2/libdb.so.2.7.7 $DESTDIR/lib
ln -sfn ../../lib/libdb.so.2.7.7 $DESTDIR/usr/lib/libdb2.so
rm $DESTDIR/usr/lib/libdb.a

ln -sfn libdb1.so $DESTDIR/usr/lib/libndbm.so
install -m 444 %{_arch}-linux-static-2/libdb.a $DESTDIR/usr/lib/libdb2.a
ln -sfn libdb1.a $DESTDIR/usr/lib/libndbm.a

install -m 555 db.1.85/PORT/linux/libdb.a $DESTDIR/usr/lib/libdb1.a
install -m 555 db.1.85/PORT/linux/libdb1.so.2.7.7 $DESTDIR/lib/
ln -sfn ../../lib/libdb1.so.2.7.7 $DESTDIR/usr/lib/libdb1.so

mkdir -p $DESTDIR/usr/include/db1
cp -p db.1.85/PORT/linux/include/{db,mpool,ndbm}.h $DESTDIR/usr/include/db1

make -C %{_arch}-linux-3 install prefix=$DESTDIR/db3
mv $DESTDIR/db3/include $DESTDIR/usr/include/db3
(cd $DESTDIR/usr/include/db3 && for i in *.h; do ln -s db3/$i ../$i; done)
mv $DESTDIR/db3/bin/* $DESTDIR/usr/bin/
rmdir $DESTDIR/db3/bin

mv $DESTDIR/db3/docs $DD/db3
rm $DESTDIR/db3/lib/libdb.so
rm $DESTDIR/db3/lib/libdb-3.so
mv $DESTDIR/db3/lib/libdb[-.]*so $DESTDIR/lib/libdb-3.3.so.%{Version}
mv $DESTDIR/db3/lib/* $DESTDIR/usr/lib
ln -s ../../lib/libdb-3.3.so.%{Version} $DESTDIR/usr/lib/libdb-3.3.so
ln -s libdb-3.3.so $DESTDIR/usr/lib/libdb-3.so
ln -s libdb-3.3.so $DESTDIR/usr/lib/libdb.so
ln -s libdb-3.3.a $DESTDIR/usr/lib/libdb.a
# shall be empty
rmdir $DESTDIR/db3/lib/
rmdir $DESTDIR/db3
chmod a+x $DESTDIR/lib/libdb-3.3.so.3.3.11
chmod a+x $DESTDIR/usr/lib/libdb_cxx-3.3.so

strip -x $DESTDIR/usr/lib/*.a

%{fixManPages}
%{fixInfoPages}

%{mkLists} -c db

%{mkLists} -a -f db <<EOP
# remember to use perl regular expressions here (see perlre(1))
/lib/lib*.so.*                          base
/usr/bin/db*_.*                         base

# devel is a hoax right now
/usr/include/.*                         devel
.*.a                                    devel
*                                       default
EOP

cat files-db-devel >> files-db-base

%Clean
%{rmDESTDIR}

%Post -p /sbin/ldconfig

%PostUn -p /sbin/ldconfig

%Files -f files-db-base
%defattr(-,root,root)
 
#%Files devel -f files-db-devel
#%defattr(-,root,root)

%ChangeLog
* Mon Jan 01 1998 ...
Template Version: 1.31

$Id: db.spec,v 1.12 2001/09/19 15:42:39 coolo Exp $
