%define _manprefix %{_mandir}%{manEN}

Summary: 	A graphical LDAP directory browser and editor.
Name: 		gq
Version: 	0.3.1
Release: 	1
Source: 	http://biot.com/gq/download/gq-%{version}.tar.gz
Patch0: 	gq-0.3.0-implicit.patch
Patch1: 	gq-0.3.0-init.patch
Patch2: 	gq-0.3.0-delete.patch
URL: 		http://biot.com/gq/
Group: 		Administration/Network
License: 	GPL
BuildRoot: 	%{_tmppath}/%{Name}-%{Version}
#BuildPrereq: 	krb5-devel, openldap-devel
BuildPrereq:  	openldap-devel

%description
GQ is a graphical browser for LDAP directories and schemas.  Using GQ,
an administrator can search through a directory and modify objects stored
in that directory.

%Prep
%setup -q
%patch0 -p1 -b .implicit
%patch1 -p1 -b .init
%patch2 -p1 -b .delete

%Build
DESTDIR=$RPM_BUILD_ROOT
CFLAGS="-ggdb $RPM_OPT_FLAGS" ; export CFLAGS

./configure --prefix=$DESTDIR%{_prefix} \
	--with-ldap-prefix=$DESTDIR%{_prefix} \
	--mandir=$DESTDIR%{_manprefix}
make

%Install
%{mkDESTDIR}

make install

docdir=$DESTDIR%{_defaultdocdir}/%{Name}-%{Version}
mkdir -p $docdir

cp {README,INSTALL,COPYING,ChangeLog,NEWS,TODO,AUTHORS} $docdir

%Clean
%{rmDESTDIR}

%Files
%defattr(-,root,root)
%{_defaultdocdir}/*
%{_bindir}/*
%{_datadir}/pixmaps/%{name}/*

%Changelog
* Wed Dec 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 0.3.1

* Fri Dec  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Fri Nov 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- initial package
