<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

// Where are we
$WEBROOT = substr($SCRIPT_NAME, 0, strpos($SCRIPT_NAME, '/', 1) + 1);
$HTTPROOT = 'http://' . $SERVER_NAME . ':' . $SERVER_PORT . '/' . $WEBROOT;

// Get the hardcoded values -- prefix may be unset
include($RELATIVE_PATH_PREFIX . './constants.inc');

// Get system configuration data
$fd = fopen($CONFIGFILE, "r");
$data = explode("\n", fread($fd, filesize($CONFIGFILE)));
fclose($fd);
while($data) {
	list($attr, $value) = split(":", array_pop($data), 2);
	switch($attr) {
		case "LDAPHOST": 
			$LDAPHost = $value;
			break;
		case "LDAPSUFFIX":
			$LDAPSuffix = $value;
			break;
		case "DN":
			$LDAPanonuser = $value;
			break;
		case "PW":
			$LDAPanonpw = $value;
			break;
		case "BIN":
			$BINDIR = $value . "/";
			break;
		case "TMP":
			$TMPDIR = $value . "/";
			break;
		case "GUIROOT":
			$GUIROOT = $value . "/";
			break;
		case "DOCROOT":
			$_DOCVIEW_ROOT = $value . "/";
			break;
		case "ADMIN":
			$LDAP_OC_ADMIN = $value;
			break;
		case "USER":
			$LDAP_OC_USER  = $value;
			break;
		default:
			break;
	}
}

// Setup Other Vars
$LOGFILE = $TMPDIR . $LOGFILE_NAME;
$EXECCMD = $BINDIR . $EXECCMD_NAME;
$_DOCVIEW_BASE = 'http://' . $SERVER_NAME . ':' . $DOCVIEW_PORT . '/';
$_DOCVIEW_URL = $_DOCVIEW_BASE . $DOCVIEW_INITIALPAGE;
$LANGPATH = 'lang/' . $LANG;
$HELPPATH = $LANGPATH . '/help';
$_DOCTYPE = $IE5 . "\n";
$includePath = $GUIROOT;

// Load other constants and objects
include $includePath . 'objs/ObjectTable.php';

include $includePath . 'objs/Alias.php';
include $includePath . 'objs/AliasList.php';
include $includePath . 'objs/AliasListUser.php';
include $includePath . 'objs/AliasListMy.php';
include $includePath . 'objs/AliasSelectList.php';
include $includePath . 'objs/Authenticate.php';
include $includePath . 'objs/Browser.php';
include $includePath . 'objs/Command.php';
include $includePath . 'objs/Domain.php';
include $includePath . 'objs/DomainList.php';
include $includePath . 'objs/File.php';
include $includePath . 'objs/FindBox.php';
include $includePath . 'objs/Help.php';
include $includePath . 'objs/LNav.php';
include $includePath . 'objs/MemberList.php';
include $includePath . 'objs/OwnerList.php';
include $includePath . 'objs/Search.php';
include $includePath . 'objs/Server.php';
include $includePath . 'objs/Service.php';
include $includePath . 'objs/ServiceList.php';
include $includePath . 'objs/Table.php';
include $includePath . 'objs/User.php';
include $includePath . 'objs/UserList.php';
include $includePath . 'objs/UserListUser.php';
include $includePath . 'objs/UserSelectList.php';


// Load message catalogs
include $includePath . $LANGPATH . '/messages/messages.inc';


// Detect Browser Capabilities
$browser = new Browser();
$_NN = $browser->getNN();
$_NN_JAVASCRIPT = '<script language="JavaScript"> var _NN = ';
if ($_NN) {
	$_NN_JAVASCRIPT .= '1';
} else { 
	$_NN_JAVASCRIPT .= '0';
}
$_NN_JAVASCRIPT .= '; </script>';


// If a session does not yet exist for this user, start one
session_start();

// Load the session variables
if (! $PHPSESSID) {
	session_register("session_dn");
	session_register("session_class");
	session_register("session_domain");
	session_register("session_user");
	session_register("session_passwd");
	session_register("session_searchObj");
	session_register("session_tableObj");
	session_register("session_serialNum");
	session_register("session_view");
	session_register("session_perms");
	session_register("passthru_error");
} else {
	if (! $session_dn)        { session_register("session_dn");        }
	if (! $session_class)     { session_register("session_class");     }
	if (! $session_domain)    { session_register("session_domain");    }
	if (! $session_user)      { session_register("session_user");      }
	if (! $session_passwd)    { session_register("session_passwd");    }
	if (! $session_searchObj) { session_register("session_searchObj"); }
	if (! $session_tableObj)  { session_register("session_tableObj");  }
	if (! $session_serialNum) { session_register("session_serialNum"); }
	if (! $session_view)      { session_register("session_view");      }
	if (! $session_perms)     { session_register("session_perms");      }
	if (! $passthru_error)    { session_register("passthru_error");      }
}

$session_serialNum++;


// Helper functions
function getSerial() {
	global $serial, $session_serialNum;
	if (isset($serial) && $serial != "") {
		return $serial;
	}
	return $session_serialNum;
}

function getMessage($msgId) {
	$message = $GLOBALS[$msgId];
	return $message;
}

function toBool($value) {
	if (strcasecmp($value, "true") == 0) {
		return true;
	}
	return false;
}

function debug($msg) {
	print("<!--$msg-->\n");
};

function isAdmin() {
	$numArgs = func_num_args();

	switch ($numArgs) {
	  case 0:
		return Authenticate::isAdmin();
		break;
	  case 1:
		$arg1 = func_get_arg(0);
		return Authenticate::isAdmin($arg1);
		break;
	  default:
		return false;
		break;
	} 
}

function stdErrorMsg($errors, $exit) {
	if (is_array($errors)) {
		$retval = join("\n", $errors);
   	} else {
		$retval = $errors . "\n";
   	}

   	if (! $exit === "") {
		$retval .= "\n" . 'Command Exit Value : ' . 
			$LAST_ERROR_EXIT . "\n";
	}

	return $retval;
}

function guilog($message) {
	global $LOGFILE;

	$fid = fopen($LOGFILE, 'a+');
	fputs($fid, time() . ":\t$message\n");
	fclose($fid);
}

function gotoURL($location) {
	header("Location: $location");
	// Netscape 4.7x and 6 seem to want some data so....
	print('<script>location.href="' . $location . '"</script>');
	exit();
}

?>
