<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

class AliasListMy extends ObjectTable {
	
	function AliasListMy($varArray, $id) {
		global $session_user;

		$cmd = new Command('msgusergetaliases');
		$cmd->add_arg('--uid', $session_user);
		$cmd->run();
		$lines = $cmd->getOutput();

		unset($this->list);

		// Populate the list 
		if ($lines != "") foreach ($lines as $line) {

			$line = trim($line);

			if ($line == "") {
				if ($alias != "") {
					$this->list[] = $alias;
					$alias = "";
				}
				continue;
			}

			if ($alias == "" && $line != "") {
				$alias = new Alias();
			}

			list($attr, $value) = split(":", $line, 2);
			switch ($attr) {
				case 'alias':
					$alias->name = $value;
					break;
				case 'owner':
					if ($value == "TRUE") {
					    $alias->ouids[] = $session_user;
					}
					break;
				case 'member':
					if ($value == "TRUE") {
					    $alias->muids[] = $session_user;
					}
					break;
				case 'description':
					$alias->description = $value;
					break;
				case 'mail':
					$alias->mail = $value;
					break;
				default:
					break;
			}
		}

		// Setup the table
		if (Table::isActive($varArray, $id)) {
			$table = Table::getActive();
			$table->setParams($varArray, $this->count());
		} else {
			$table = new Table($id);

			$name = getMessage('MSG_ALIASES_HEADING_NAME');
			$table->addDataColumn($name, Column::ASCEND(),
				 'name', "return Go('aliasview.php?mail=%%ROWID%%')");

			$name = getMessage('MSG_ALIASES_HEADING_DESCRIPTION');
			$table->addDataColumn($name, Column::ASCEND(), 'description');

			$name = 'Owner';
			$table->addDataColumn($name, Column::ASCEND(), 'owner');

			$name = 'Member';
			$table->addDataColumn($name, Column::ASCEND(), 'member');

			//$name = "Remove";
			//$table->addDisplayColumn($name,
			//	"return Go('aliasremoveuser&mail=" . $session_user . "')");

			$table->setParams($varArray, $this->count());
			$table->setSortedColumn($table->firstSortedColumn());
		}

		// Apply sorting
		$attr = $table->getSortAttrName($table->getSortedColumn());
		$dir  = $table->getColumnSortDir($table->getSortedColumn());
		$this->sort(AliasListMy::comparisonFunctionName($attr ,$dir));


		// Save table
		$this->table = $table;
		$this->table->save();
	}

	function getListValue($index, $col="-1") {
		// if now $col then return the row value (unique id)
		if ($col == "-1") return $this->list[$index]->getMail();

		switch ($col) {
			case '0':
			case 'name':
				$retval = $this->list[$index]->getName();
				break;
			case '1' :
			case 'description':
				$retval = $this->list[$index]->getDescription();
				// only show the first 30 chars
				$retval = substr($retval, 0, 30);
				break;
			case '2' :
			case 'owner' :
				$retval = ($this->list[$index]->ouids) ?
					'yes' : 'no';
				break;
			case '3' :
			case 'member' :
				$retval = ($this->list[$index]->muids) ?
					'yes' : 'no';
				break;
			case '4' :
				$retval = $this->table->getTemplate('deleteIcon');
				$retval = stripslashes($retval);
				break;
			default:
				$retval = "";
				break;
		}

		return $retval;
	}

	function comparisonFunctionName($field, $direction) {
		switch($field) {
			case "name":
				$cmpFunction = "byAliasName";
				break;
			case "description":
				$cmpFunction = "byAliasDescription";
				break;
			case "owner":
				$cmpFunction = "byAliasMyOwner";
				break;
			case "member":
				$cmpFunction = "byAliasMyMember";
				break;
			default:
				$cmpFunction = "byAliasName";
				break;
		}

		switch($direction) {
			case "a":
				$cmpFunction .= "Ascend";
				break;
			case "d":
				$cmpFunction .= "Decend";
				break;
			default:
				$cmpFunction .= "Acend";
				break;
		}
		return $cmpFunction;
	}

}

function byAliasMyOwnerAscend($left, $right) {
	$i  = ($left->ouids) ? 1 : 0;
	$i += ($right->ouids) ? -1 : 0;
	return ($i == 0) ? strcasecmp($left->name,$right->name) : $i;
}

function byAliasMyOwnerDecend($left, $right) {
	return(-1 * (byAliasMyOwnerAscend($left, $right)));
}

function byAliasMyMemberAscend($left, $right) {
	$i  = ($left->muids) ? 1 : 0;
	$i += ($right->muids) ? -1 : 0;
	return ($i == 0) ? strcasecmp($left->name,$right->name) : $i;
}

function byAliasMyMemberDecend($left, $right) {
	return(-1 * (byAliasMyMemberAscend($left, $right)));
}

?>
