<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

class Command {

	var $pipe;
	var $linesize;
	var $cmd;
	var $execcmd;
	var $path;
	var $mode;
	var $exitval;
	var $sessionFile;
	var $sessionKey;
	var $output;
	var $log;
	
	function Command($cmd) {
		$this->cmd = $cmd;
		$this->linesize = $GLOBALS['COMMAND_INPUT_LINE_SIZE'];
		$this->execcmd = $GLOBALS['EXECCMD'];
		$this->path = $GLOBALS['BINDIR'];
		$this->sessionFile = Authenticate::getSessionFile();
		$this->sessionKey = Authenticate::getCurrentKey();
		$this->mode = "r";
		$this->log = false;
	}

	function concat() {
		$cmd = $this->execcmd;
		$cmd .= " " . $this->sessionFile;
		$cmd .= " " . $this->path . $this->cmd;
		$cmd .= " " . "2>&1";
		
		return $cmd;
	}

	function add_arg($attr, $value = '') {
                if ($value !== '') {
                        $value = escapeshellarg($value);
                }
		if ($attr !== '' && $value !== '') {
                	$this->cmd .= " $attr=$value ";
		} elseif ($attr !== '') {
                	$this->cmd .= " $attr ";
		} else {
                	$this->cmd .= " $value ";
		}
 
                return true;
        }

	function open () {
		$cmd = $this->concat();
		if ($this->log == true) guilog($cmd);
		$this->pipe = popen($cmd, $this->mode);
		unset($this->output);
	}
	
	function close() {
		// fetch and save any uncollected output
		unset($this->output);
		while ($line = fgets($this->pipe, $this->linesize)) {	
			$this->output[] = trim($line);
		} 

		// the pclose exit value is return value of 
		// waitpid() of wait4().  The bitwise operations deal with it
		//$this->exitval = (pclose($this->pipe)>>8)&0xFF;
		$this->exitval = pclose($this->pipe);
	}

	function doexec() {
		$cmd = $this->concat();
		$key = $this->sessionKey;

                exec($cmd, $array, $retval, $key);
                $this->exitval = $retval;

                unset($this->output);
                foreach ($array as $line) {
                        $this->output[] = $line;
                }

		if ($this->log == true) {
                	guilog('cmd=' . $cmd);
			guilog('exit=' . $this->exitval);
			if ($this->exitval != 0) {
				guilog('error=' . stdErrorMsg($this->output, $this->exitval));
			}
		}
	}

	function getExitVal() {
		if (isset($this->exitval)) {
			return $this->exitval;
		}
		return;
	}

	function getErrors() {
		return $this->output;
	}
	
	function printErrors() {
		if ($this->output != "") {
			foreach ($this->output as $line) {
				print("$line\n");
			}
		}
	}
	
	function getOutput() {
		return $this->output;
	}

	function run() {
		$this->doexec();
	}

	function backtick($cmd) {
		$tmp = new Command($cmd);
		$cmd = $tmp->concat();
		return `$cmd`;
	}

}

?>
