<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

class Help {

	var $id;
	var $page;
	var $valid;

	function Help($id) {
		global $HELPPATH, $_DOCVIEW_ROOT, $LANG;
		$this->id = $id;
		$this->valid = false;

		// Old way
		//$this->page = "./$HELPPATH/" . $id . '.html';
		//
		//if (is_readable($this->page)) {
		//	$this->valid = true;
		//}

		$this->page = $LANG . '/' . $this->_map($id);
		$filename = ereg_replace('#.*$', '', $_DOCVIEW_ROOT . $this->page);
		if (is_file($filename)) {
			$this->valid = true;
		}

		$this->page = '/msghelp/' . $this->page;

	}

	function display() {
		if ($this->valid) {
			// Old way
			//$this->_display_old();

			$this->_display();
		} else {
			$this->_display_invalid();
		}
	}

	function _display() {
		gotoURL($this->page);
	}

	function _display_old() {
		$template = './help/template.html';

		$_HELPTEXT = File::readFile($this->page);
		$html = File::readFile($template);

		$html = ereg_replace('%%HELPTEXT%%', $_HELPTEXT, $html);

		print($html);
	}

	function _display_invalid() {
		global $HELPPATH;

		$this->page = "./$HELPPATH/nohelp.html";
		$this->_display_old();
	}

	function _map($mapid) {
		global $session_user, $HELP_LOGINMAP, $HELP_USERMAP,
			$HELP_ADMINMAP;

		if (! $session_user) {
			$mapfile .= $HELP_LOGINMAP;
		} elseif (isAdmin()) {
			$mapfile .= $HELP_ADMINMAP;
		} else {
			$mapfile .= $HELP_USERMAP;
		}

		$map = split("\n", File::readFile($mapfile));
		foreach ($map as $i) {
			list($id, $val) = split(':', $i, 2);
			if ($id == $mapid) {
				return $val;
			}
		}

		return '';
	}
	
}

?>
