<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

class OwnerList extends ObjectTable {
	
	var $alias;

	function OwnerList($aliasObj, $varArray, $id) {


		if ($aliasObj == '') {
			$this = '';
			return;
		} else {
			$this->alias = $aliasObj;
		}

		if ($this->alias->owners) foreach ($this->alias->owners as $o) {
			$this->list[] = new Owner($o);
		}

		// Setup the table
		if (Table::isActive($varArray, $id)) {
			$table = Table::getActive();
			$table->setParams($varArray, $this->count());

			$this->setActionExtra('&mail=' . $this->alias->mail);
		} else {
			$table = new Table($id);

			$name = "Mail";
			$table->addDataColumn($name, Column::ASCEND(),
				'name', "return Go('userview.php?mail=%%ROWID%%')");

			if ($this->alias->isOwner($GLOBALS['session_user']) ||
				isAdmin()) {
			$name = "Remove";
			$table->addDisplayColumn($name,
				"return Go('aliasremoveowner_action.php?mail=" .
				$this->alias->mail . 
				"&_owners=%%ROWID%%')");
			}

			$table->setParams($HTTP_GET_VARS, $this->count());
			$table->rows = 5;
			$table->setSortedColumn($table->firstSortedColumn());

			$this->setActionExtra('&mail=' . $this->alias->mail);
		}

		// Apply sorting
		$attr = $table->getSortAttrName($table->getSortedColumn());
		$dir  = $table->getColumnSortDir($table->getSortedColumn());
		$this->sort(Owner::comparisonFunctionName($attr ,$dir));

		// Save table
		$this->table = $table;
		$this->table->save();
	}


	function getListValue($index, $col="-1") {
		// if now $col then return the row value (unique id)
		if ($col == "-1") return $this->list[$index]->getMail();

		switch ($col) {
			case '0':
			case 'name':
				$retval = $this->list[$index]->getName();
				break;
			case '1' :
				$retval = $this->table->getTemplate('deleteIcon');
				$retval = stripslashes($retval);
				break;
			default:
				$retval = "";
				break;
		}

		return $retval;
	}

	function getNav() {
		global $_SELF, $_SERIAL;
	
		$current = (int)($this->table->offset / $this->table->rows) + 1;

		$total = (int)($this->count() / $this->table->rows);
		if ($this->count() % $this->table->rows > 0) {
			$total++;
		} elseif ($this->count() == 0) {
			$total = 1;
		}
	
		$retval = '<div class="tablenav">';
		$retval .= "Page $current of $total";
		if ($total == 1) {
			return $retval;
		}
 		$retval .= " : ";
		if ($current > 1) {
			$offset = ($current - 2) * $this->table->rows;
			$href = $_SELF .  '?mail=' . $this->alias->mail . '&offset=' .
				$offset .
				'&serial=' . $_SERIAL;
			$retval .= ' <a href="' . $href . '" class="tablenav">&lt;&lt;Prev</a> ';
		}
		for ($i = 1; $i <= $total; $i++) {
			$offset = ($i - 1) * $this->table->rows;
			$href = $_SELF .  '?mail=' . $this->alias->mail . '&offset=' .
				$offset .
				'&serial=' . $_SERIAL;
			if ($current != $i) {
				$retval .= ' <a href="' . $href . '" class="tablenav">' . $i . '</a> ';
			} else {
				$retval .= " $i ";
			}
		}
		if ($current < $total) {
			$offset = ($current) * $this->table->rows;
			$href = $_SELF .  '?mail=' . $this->alias->mail . '&offset=' .
				$offset .
				'&serial=' . $_SERIAL;
			$retval .= ' <a href="' . $href . '" class="tablenav">Next&gt;&gt;</a> ';
		}
		$retval .= '</div>' . "\n";

		return $retval;

	}

	function renderList() {
		$retval = '<div style="background-color:white;width:475;height:100;overflow:auto;text-align:left;padding:5">' . "\n";
		$first = true;
		foreach ($this->list as $mgeneric) {
			if (! $first) {
				$retval .= (",\n ");
			} else {
				$first = false;
			}

			$close = false;
			$class = get_class($mgeneric);
			if ($class == "muser") {
				$retval .= '<a href="userview.php?uid=' . $mgeneric->name . '">';
				$close = true;
			} elseif ($class == "malias") {
				$retval .= '<a href="aliasview.php?mail=' . $mgeneric->name . '">';
				$close = true;
			}

			$retval .= "$mgeneric->name";

			if ($close) {
				$retval .= '</a>';
			}
		}
		$retval .= '</div>' . "\n";

		return $retval;
	}
}


class Owner {
	var $mail;

	function Owner($mail) {
		$this->mail = $mail;
	}

	function comparisonFunctionName($field, $direction) {
		switch($field) {
			case "name":
				$cmpFunction = "_owner_byName";
				break;
			case "class":
				$cmpFunction = "_owner_byClass";
				break;
			default:
				$cmpFunction = "_owner_byName";
				break;
		}

		switch($direction) {
			case "a":
				$cmpFunction .= "Ascend";
				break;
			case "d":
				$cmpFunction .= "Decend";
				break;
			default:
				$cmpFunction .= "Acend";
				break;
		}
		return $cmpFunction;
	}

	function getMail() {
		global $session_domain;

		return $this->mail;
	}

	function getName() {
		$pos = strpos($this->mail, '@');
		if ($pos === false) {
			$retval = $this->mail;
		} else {
			$retval = substr($this->mail, 0, $pos);
		}
		
		return $retval;
	}
}

/*
 * Ideally these comparison functions would be encapsulated in the 
 * User class as class methods. Can't work out how to pass a class
 * method to the usort() function yet.
 */
function _owner_byNameAscend($left, $right) {
	return(strcasecmp($left->mail,$right->mail));
}

function _owner_byNameDecend($left, $right) {
	return(-1 * (_owner_byNameAscend($left, $right)));
}

?>
