<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

class Search {
	var $active;
	var $attr;
	var $value;
	var $op;
	var $id;
	var $ops = array("is", "is not", "starts with", "ends with",
			 "contains");

	function Search($varArray, $id) {
		if ($varArray['findText'] == "") {
			$this = "";
			return;
		}
		$this->value = $varArray['findText'];
		$this->id = $id;

		if ($varArray['findOp'] == "") {
			$this->op = "contains";
		} else {
			$this->op = $varArray['findOp'];
		}

		if ($varArray['findAttr'] == "") {
			$this->attr = "";
		} else {
			$this->attr = $varArray['findAttr'];
		}
	}

	function isRequested($varArray) {
		if ($varArray['findAttr'] != "" &&
		    $varArray['findText'] != "" &&
		    $varArray['findOp'] != ""      ) {
	
			return true;
		}
		if ($varArray['findText'] != "" &&
		    $varArray['findAttr'] == "" &&
		    $varArray['findOp'] == ""      ) {
			return true;
		}
		return false;
	}

	function isActive($id) {
		global $session_searchObj;
		if ($session_searchObj != "") {
			if ($session_searchObj->getId() == $id) {
				return true;
			}
		}
		return false;
	}

	function getActive() {
		global $session_searchObj;
		if ($session_searchObj == "") {
			return "";
		}
		return $session_searchObj;
	}

	function getId() {
		return $this->id;
	}

	function getAttr() {
		return $this->attr;
	}

	function setAttr($value) {
		$this->attr = $value;
	}

	function getValue() {
		return $this->value;
	}

	function setValue($value) {
		$this->value = $value;
	}

	function getOp() {
		return $this->op;
	}

	function setOp($value) {
		$this->op = $value;
	}

	function save() {
		global $session_searchObj;
		
		$session_searchObj = $this;
	}

	function getExpression() {
		switch ($this->op) {
			case "is":
				$retval = "^" . $this->value . "\$";
				break;
			case "is not":
				$retval = "^" . $this->value . "\$";
				break;
			case "starts with":
				$retval = "^" . $this->value;
				break;
			case "ends with":
				$retval = $this->value . "\$";
				break;
			case "contains":
				$retval = $this->value;
				break;
			default:
				$retval = "^";
				break;
		}
		return $retval;
	}

	function isNegated() {
		switch ($this->op) {
			case "is not":
				$retval = true;
				break;
			default:
				$retval = false;
				break;
		}
		return $retval;
	}

	function clear() {
		$GLOBALS['searchObj'] = "";
	}

}

?>
