<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

class Server {

	var $passwdWrite;    // s, boolean
	var $profileWrite;   // s, boolean
	var $aliasCreate;    // s, boolean

	function Server() {
		$numArgs = func_num_args();
		if ($numArgs != 0) {
			return; // create an empty server object
		}

		$cmd = new Command('msgaclget');
		$cmd->run();
		$lines = $cmd->getOutput();

		if ($lines != "") foreach ($lines as $line) {
			$line = trim($line);

			if ($line != "") {
				list($attr, $value) = split(":", $line, 2);

				switch ($attr) {
					case "AllowUserPasswordWrite" :
						$this->passwdWrite =
							toBool($value);
						break;
					case "AllowUserAliasCreate" :
						$this->aliasCreate =
							toBool($value);
						break;
					case "AllowUserConfigWrite" :
						$this->profileWrite =
							toBool($value);
						break;
					default:
						break;
				}
			}
		}
	}

	function _validate($attr, $val) {
		$retval = false;
		switch ($attr) {
			default:
				if ($val == "true" || $val == "false")
				$retval = true;
				break;
		}

		return $retval;
	}

	function save() {
	}

	function unsave() {
	}

	function _getOption($attr) {
		switch ($attr) {
			case "_passwdWrite" :
			case "passwdWrite" :
				$retval = "--AllowUserPasswordWrite";
				break;
			case "_aliasCreate" :
			case "aliasCreate" :
				$retval = "--AllowUserAliasCreate";
				break;
			case "_profileWrite" :
			case "profileWrite" :
				$retval = "--AllowUserConfigWrite";
				break;
			default:
				$retval = "";
		}

		return $retval;
	}

	function modify($varArray) {
		$cmd = new Command('msgaclset');

		if ($GLOBALS['LDAPHost'] != 'localhost') {
			$GLOBALS['LAST_ERROR'][] = getMessage('ERR_ACLSET_NOTLOCALHOST');
			return false;
		}

		$current = get_object_vars($this);

		while (list ($attr, $val) = each ($varArray)) {

			$val = trim($val);

			$attr = str_replace("_", "", $attr);

			if (! $this->_validate($attr, $val)) continue;

			if ($current[$attr] == $val) continue;

			$opt = $this->_getOption($attr);
			$val = strtoupper($val);
			if ($opt != "") {
				$cmd->add_arg($opt, $val);
			}
		}

		$cmd->run();

		if ($cmd->getExitVal() == 0) {
			return true;
		}
		$GLOBALS['LAST_ERROR'] = $cmd->getErrors();
		$GLOBALS['LAST_ERROR'][] = "\non command:\n" . $cmd->concat();
		$GLOBALS['LAST_ERROR_EXIT'] = $cmd->getExitVal();
		return false;
	}

	function formExport() {
		$attrs = get_object_vars($this);
		foreach ($attrs as $attr => $val) {
			$GLOBALS["_$attr"] = $val;
		}
	}

	function canChangeProfile() {
		return $this->profileWrite;
	}

	function canChangePassword() {
		return $this->passwdWrite;
	}

	function canCreateAliases() {
		return $this->aliasCreate;
	}

}

?>
