<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */

class ServiceList extends ObjectTable {
	function ServiceList($varArray, $id) {
		$this->list = "";
		$cmd = new Command('msgservicelistall');
		$cmd->add_arg('--service --status');
		$cmd->run();
		$lines = $cmd->getOutput();

		unset($this->list);

		// Populate the list 
		if ($lines != "") foreach ($lines as $line) {

			$line = trim($line);

			if ($line == "") {
				if ($service != "") {
					$this->list[] = $service;
					$service = "";
				}
				continue;
			}

			if ($service == "" && $line != "") {
				$service = new Service();
			}

			list($attr, $value) = split(":", $line, 2);
			$service->setAttr($attr, $value);
		}

		// Setup the table
		if (Table::isActive($varArray, $id)) {
			$table = Table::getActive();
			$table->setParams($varArray, $this->count());
		} else {
			$table = new Table($id);

			$name = "Service";
			$table->addDataColumn($name, Column::ASCEND(), 'name',
				"return Go('serviceview.php?service=%%ROWID%%')");

			$name = "Status";
			$table->addDataColumn($name, Column::ASCEND(), 'status');
			$table->setParams($HTTP_GET_VARS, $this->count());
			$table->setSortedColumn($table->firstSortedColumn());
		}

		// Apply sorting
		$attr = $table->getSortAttrName($table->getSortedColumn());
		$dir  = $table->getColumnSortDir($table->getSortedColumn());
		$this->sort(Service::comparisonFunctionName($attr ,$dir));

		// Save table
		$this->table = $table;
		$this->table->save();
	}

	function getListValue($index, $col="-1") {
		// if now $col then return the row value (unique id)
		if ($col == "-1") return $this->list[$index]->name;

		switch ($col) {
			case '0':
			case 'name':
				$retval = $this->list[$index]->name;
				break;
			case '1' :
			case 'status':
				$retval = $this->list[$index]->status;
				break;
			default:
				$retval = "";
				break;
		}

		return $retval;
	}

}

?>
