<?php
/*
 * Copyright (C) 2001 Caldera International, Inc.  All Rights Reserved.
 */


include("./include.php");

$file = "." . $PATH_INFO;
$pgpath = $SCRIPT_NAME;

$_SERIAL = getSerial();
$_SELF = basename($file);

$_BUTTON_HELP_LINK = 'return Help(\'nohelp\')';
$_BUTTON_CANCEL_LINK = 'return Go(\'action_cancel.php\')';
$_BUTTON_BACK_LINK = 'return Back()';
$_BUTTON_DOCVIEW_LINK = "return DocViewWindow('$_DOCVIEW_URL')";

if ($_SELF == 'auth.php') {
	include('./login/auth.php');
	exit();
}

if ($_SELF == 'preferences.php') {
	include('./login/preferences.php');
	include('./login/template/main.html');
	exit();
}

if (! Authenticate::isAuthenticated()) {
	include('./login/login.php');
	include('./login/template/main.html');
	exit();
}

if ($auth == 'logout' || $auth == 'forcelogout') {
	// Destroy the session
	include('./login/login.php');
	include('./login/template/main.html');
	Authenticate::clearCryptKey();
	session_unset();
	session_destroy();
	exit();
}

if ($_SELF == "login.php") {
	include('./login/login.php');
	include('./login/template/main.html');
	@Authenticate::clearCryptKey();
	@session_unset();
	@session_destroy();
	exit();
}

//if (! Authenticate::recryptPassword()) {
//	include('./login/login.php');
//	include('./login/template/main.html');
//	exit();
//}

$_SESSION_USER = $session_user;
$_TITLEICON = 'main_ico_blank.gif';
$_TITLEGRAPHIC = 'main_title_blank.gif';
$_BUTTON_LOGOUT_LINK = 'return Logout()';

if (isAdmin()) {
	if (isset($HTTP_GET_VARS['s_domain'])) {
		$s_domain = $HTTP_GET_VARS['s_domain'];
		$doms = new DomainDropList();
		if ($doms->isDomain($s_domain)) {
			$session_domain = $s_domain;
		}
	}
	$dir = 'admin';

	$_OBJ_DOMAINDROPLIST = new DomainDropList();
	$_DOCVIEW_URL = $_DOCVIEW_BASE . $DOCVIEW_ADMINPAGE;
	$_BUTTON_DOCVIEW_LINK = "return DocViewWindow('$_DOCVIEW_URL')";
} else {
	$_CAN_CREATE_ALIASES = $session_perms->canCreateAliases();
	$_CAN_CHANGE_PASSWORD = $session_perms->canChangePassword();
	$_CAN_CHANGE_PROFILE = $session_perms->canChangeProfile();
	$dir = 'user';

	$_DOCVIEW_URL = $_DOCVIEW_BASE . $DOCVIEW_USERPAGE;
	$_BUTTON_DOCVIEW_LINK = "return DocViewWindow('$_DOCVIEW_URL')";
}

$nopage = './' . $dir . '/nopage.php';

// rewrite the file name for security
if ($file == './' . basename($file)) {
	$file = './' . $dir . '/' . basename($file);
} else {
	gotoURL($pgpath . '/nopage.php');
}

// check that the file exists and is readable
if (! is_readable($file)) {
	$file = $nopage;
}

# check that file extention indicates a valid type
if (substr($file, -4) != '.php') {
	if (substr($file, -6) != '.phtml') {
		if (substr($file, -5) != '.html') {
			if (substr($file, -6) != '.htmlf') {
				$file = $nopage;
			}
		}
	}
}

include($file);

if (! $dialogonly) {
	$_MAIN_NAVIGATION = File::parseFile('./' . $dir . '/template/nav.html');
	include('./' . $dir . '/template/main.html');
} else {
	include('./' . $dir . '/template/main_dialogonly.html');
}

$session_view = $WEBROOT . 'pg.php' . substr($file, strpos($file, '/'));
if ($QUERY_STRING != "") {
	$session_view .= '?' . $QUERY_STRING;
}

?>
