Summary: Perl Convert::ASN1 module
Summary(pt_BR): Perl Convert
Summary(es): Perl Convert
%define PackageName Convert-ASN1
%define _mandir %{_prefix}/share/man
%define _defaultdocdir %{_usr}/share/doc/packages
Name: perl-%{PackageName}
Prereq: perl
Version: 0.07
Release: 4cl
License: Perl
Group: Libraries
Group(pt_BR): Bibliotecas
Group(es): Bibliotecas
Source: http://www.perl.com/CPAN/modules/by-module/Convert/%{PackageName}-%{version}.tar.gz
URL: http://www.perl.com/CPAN/modules/by-module/Convert/%{PackageName}-%{version}.readme
BuildRoot: %{_tmppath}/%{name}-%{version}-root


%description
This modules provides a ASN.1 Encode/Decode library to Perl

%description -l pt_BR
Mdulo Perl para codificar/decodificar ASN.1

%description -l es
This modules provides a ASN.1 Encode/Decode library to Perl

%prep
%setup -q -n %{PackageName}-%{version}



%build

#get perl's version
eval "perl_`perl '-V:version'`"
eval "perl_`perl '-V:installman1dir'`"
eval "perl_`perl '-V:installman3dir'`"
eval "perl_`perl '-V:man1ext'`"
eval "perl_`perl '-V:man3ext'`"

if test  $perl_version = '5.00503'  ; then
        perl_prefix=''
elif test $perl_version = '5.6.0' ; then
        perl_prefix=%{buildroot}
else
        perl_perfix=%{buildroot}
fi


#Some modules require POLLUTE=1 in the next line
CFLAGS="$RPM_OPT_FLAGS" perl Makefile.PL \
INSTALLMAN1DIR=$perl_prefix$perl_installman1dir \
INSTALLMAN3DIR=$perl_prefix$perl_installman3dir


make OPTIMIZE="${RPM_OPT_FLAGS}"
make test


%install
rm -rf %{buildroot}

eval `perl '-V:installarchlib'`
eval "perl_`perl '-V:version'`"
eval "perl_`perl '-V:installman1dir'`"
eval "perl_`perl '-V:installman3dir'`"
eval "perl_`perl '-V:man1ext'`"
eval "perl_`perl '-V:man3ext'`"
    
mkdir -p %{buildroot}$installarchlib 
mkdir -p %{buildroot}$perl_installman1dir
mkdir -p %{buildroot}$perl_installman3dir
mkdir -p %{buildroot}%{_libdir}/perl5/perllocal

make PREFIX=%{buildroot}%{_prefix} install

#Get the file "perllocal.pod" location
find %{buildroot}%{_prefix} -type f -print | grep perllocal.pod > podfile_full.lst

#Correct the data inside the file
perl -pi -e "s@%{buildroot}@@g"  `cat podfile_full.lst`

#move it to docs
mv `cat podfile_full.lst` .
perl -pi -e 's@%{buildroot}@@g' podfile_full.lst

cp perllocal.pod %{buildroot}%{_libdir}/perl5/perllocal/%{name}-perllocal.pod
cp podfile_full.lst %{buildroot}%{_libdir}/perl5/perllocal/%{name}-podfile_full.lst

#Get the filelist     \
#Add gz to man pages
find %{buildroot}%{_prefix} -type f -print |\
  sed -e "s@^%{buildroot}@@g" |\
  sed -e "s@\($perl_installman1dir/.*\.$perl_man1ext\)\$@\1\.gz@" |\
  sed -e "s@\($perl_installman3dir/.*\.$perl_man3ext\)\$@\1\.gz@" |\
  sed -e "s@\($perl_installman1dir/.*\.1\)\$@\1\.gz@" |\
  sed -e "s@\($perl_installman3dir/.*\.3\)\$@\1\.gz@" \
> file-list.lst
#gzip the man pages
find %{buildroot}$perl_installman3dir -type f -print | xargs gzip

#get the dirs
find %{buildroot}%{_libdir}/perl5 -type d -print |\
  perl -p -e "s@^%{buildroot}@@" |\
  perl -p -e "s@^%{_libdir}/perl5\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/$perl_version\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/$perl_version/i386-linux\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/$perl_version/i386-linux/auto\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/perllocal\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl/$perl_version\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl/$perl_version/i386-linux\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl/$perl_version/i386-linux/auto\n@@" |\
  perl -p -e "s@^@%dir @" \
>> file-list.lst


%clean
rm -rf %{buildroot}

%files -f file-list.lst
%defattr(-,root,root)
%defattr(0644,root,root,0755)
%doc README
%doc ChangeLog
%doc MANIFEST
%doc htdocs/
%doc examples/


%post
#Adjusts the date too
perl -p -e '$t=localtime;s@(^=head2 ).*(:.*)$@$1$t$2@' %{_libdir}/perl5/perllocal/%{name}-perllocal.pod \
>> `perl -p -e '' %{_libdir}/perl5/perllocal/%{name}-podfile_full.lst`

%changelog
* Mon Oct 31 2000 Raul Dias <rsd@conectiva.com>
- Changed perl from "Requires:" to "Prereq:".

* Sat Oct 28 2000 Raul Dias <rsd@conectiva.com>
- Updated spec file
- eliminate sed use

* Sat Sep 23 2000 Raul Dias <rsd@conectiva.com>
 - first build
