Name: 		perl-ldap
Version: 	0.22
Release: 	5

Summary: 	A colection of modules to work with ldap servers
Summary(pt_BR):	Uma coleo de mdulos perl para trabalhar com servidores LDAP
Summary(es): 	A colection of modules to work with ldap servers

Group: 		Libraries
Group(pt_BR): 	Bibliotecas
Group(es): 	Bibliotecas

License: 	Artistic
Source: 	http://perl-ldap.sourceforge.net/%{Name}-%{Version}.tar.gz
BuildPrereq: perl-Convert-ASN1

BuildRoot: %{_tmppath}/%{Name}-%{Version}

%Description
The perl-ldap distribution is a collection of perl modules 
which provide an object orientated interface to LDAP servers.

%Description -l pt_BR
Uma coleo de mdulos perl para trabalhar com servidores LDAP

%Description -l es
The perl-ldap distribution is a collection of perl modules 
which provide an object orientated interface to LDAP servers.

%Prep
%setup -q -n %{Name}-%{Version}

%Build
DESTDIR=$RPM_BUILD_ROOT
#get perl's version
eval "perl_`perl '-V:installman1dir'`"
eval "perl_`perl '-V:installman3dir'`"

#Some modules require POLLUTE=1 in the next line
CFLAGS="$RPM_OPT_FLAGS" perl Makefile.PL \
INSTALLMAN1DIR=$DESTDIR$perl_installman1dir \
INSTALLMAN3DIR=$DESTDIR$perl_installman3dir

make OPTIMIZE="${RPM_OPT_FLAGS}"
make test


%Install
%{mkDESTDIR}
eval "perl '-V:installarchlib'"
eval "perl_`perl '-V:version'`"
eval "perl_`perl '-V:installman1dir'`"
eval "perl_`perl '-V:installman3dir'`"
eval "perl_`perl '-V:man1ext'`"
eval "perl_`perl '-V:man3ext'`"

mkdir -p $DESTDIR/$installarchlib
mkdir -p $DESTDIR$perl_installman1dir
mkdir -p $DESTDIR$perl_installman3dir
mkdir -p $DESTDIR%{_libdir}/perl5/perllocal

make PREFIX=$DESTDIR%{_prefix} install

#Get the file "perllocal.pod" location
find $DESTDIR%{_prefix} -type f -print | grep perllocal.pod > podfile_full.lst
perl -pi -e "s@$DESTDIR@@g"  `cat podfile_full.lst`
#move it to docs
mv `cat podfile_full.lst` .
perl -pi -e "s@$DESTDIR@@g" podfile_full.lst
cp perllocal.pod $DESTDIR%{_libdir}/perl5/perllocal/%{Name}-perllocal.pod
cp podfile_full.lst $DESTDIR%{_libdir}/perl5/perllocal/%{Name}-podfile_full.lst

#Get the filelist     \
#Add gz to man pages
find $DESTDIR%{_prefix} -type f -print |\
  sed -e "s@^$DESTDIR@@g" |\
  sed -e "s@\($perl_installman1dir/.*\.$perl_man1ext\)\$@\1\.gz@" |\
  sed -e "s@\($perl_installman3dir/.*\.$perl_man3ext\)\$@\1\.gz@" |\
  sed -e "s@\($perl_installman1dir/.*\.1\)\$@\1\.gz@" |\
  sed -e "s@\($perl_installman3dir/.*\.3\)\$@\1\.gz@" \
> file-list.lst
#gzip the man pages
gziplist=`find $DESTDIR$perl_installman1dir -type f -name \*\.$perl_man1ext`
[ -n "$gziplist" ] && echo $gziplist | xargs gzip
gziplist=`find $DESTDIR$perl_installman3dir -type f -name \*\.$perl_man3ext`
[ -n "$gziplist" ] && echo $gziplist | xargs gzip
gziplist=`find $DESTDIR$perl_installman1dir $DESTDIR$perl_installman3dir -type f -name \*\.[13]`
[ -n "$gziplist" ] && echo $gziplist | xargs gzip

#get the dirs
find $DESTDIR%{_libdir}/perl5 -type d -print |\
  perl -p -e "s@^$DESTDIR@@" |\
  perl -p -e "s@^%{_libdir}/perl5\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/$perl_version\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/$perl_version/i386-linux\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/$perl_version/i386-linux/auto\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/perllocal\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl/$perl_version\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl/$perl_version/i386-linux\n@@" |\
  perl -p -e "s@^%{_libdir}/perl5/site_perl/$perl_version/i386-linux/auto\n@@" |\
  perl -p -e "s@^@%dir @" \
>> file-list.lst

# copy over docs
docdir=$DESTDIR%{_defaultdocdir}/%{Name}-%{Version}
mkdir -p $docdir
mkdir -p $docdir/{htdocs,contrib}
mkdir -p $docdir/htdocs/{Authen,Bundle,Net}
cp {README,RELEASE_NOTES,ChangeLog,TODO,INSTALL,MANIFEST} $docdir
cp -r htdocs/* $docdir/htdocs
cp contrib/* $docdir/contrib


%Post
#Adjusts the date too
perl -p -e '$t=localtime;s@(^=head2 ).*(:.*)$@$1$t$2@' %{_libdir}/perl5/perllocal/%{Name}-perllocal.pod \
>> `perl -p -e '' %{_libdir}/perl5/perllocal/%{Name}-podfile_full.lst`


%Clean
%{rmDESTDIR}


%Files -f file-list.lst
%defattr(-,root,root)
%defattr(0644,root,root,0755)
%{_defaultdocdir}/*


%Changelog
* Mon Feb 19 2001 Scott Simmons <simmons@sco.com>
- Changed Prereq to include perl-modules which has packages for perl-Digest-MD5
- perl-URI and removed references to these two packages. Note that perl-ldap
- uses perl-URI 1.08 or later. The perl-modules rpm has perl-URI 1.07. 

