%define Apxs			%(type -path apxs || echo "/usr/sbin/apxs")
%define ApacheDataDir		%(%{Apxs} -q DATADIR)
%define ApacheLibexecDir	%(%{Apxs} -q LIBEXECDIR)
%define ApacheSysconfDir	%(%{Apxs} -q SYSCONFDIR)

%define JAVAhome		/usr/java

Name        	: php
Version     	: 4.0.4pl1
Release     	: 5 
Group       	: Server/WWW

Summary     	: PHP: Hypertext Preprocessor.

Copyright   	: The PHP license
Packager    	: Stephan Seyboth <sps@caldera.de>
Icon        	: php4.gif
URL         	: http://www.php.net/

Requires    	: apache-eapi

BuildRoot   	: /tmp/%{Name}-%{Version}

Source0: http://www.php.net/distributions/php-%{Version}.tar.gz
# there is only one manual now for php3 and php4, split this off 
# changes in place, don't confuse M2! date of tarball: 2000-08-22
# Source1: http://www.php.net/distributions/manual.tar.gz
Source1: manual.tar.gz

Patch0: php-4.0.4pl1-buildroot.patch
Patch1: php-4.0.4pl1-exec_input.patch
Patch2: php-4.0.4pl1-session_id.patch

%Package doc
Group       	: Server/WWW

Summary     	: Online manual for PHP.


%Description
PHP is an HTML-embedded scripting language that allows web developers to 
write dynamically generated pages quickly.  This package contains the 
dynamically loadable PHP4 module for the popular Apache webserver.

%Description doc
Comprehensive html documentation for the PHP language, including an 
online manual and function references.

%Prep
%setup -n php-%{Version}
%patch0 -p1 -b .buildroot
%patch1 -p1 
%patch2 -p0

%Build
# we touched these with buildroot patch
autoconf

CFLAGS=`%{Apxs} -q CFLAGS` \
./configure \
        --prefix=/usr \
        --with-config-file-path=%{ApacheSysconfDir} \
        --disable-debug \
        --enable-safe-mode \
        --with-exec-dir=/usr/bin \
        --enable-track-vars \
        --enable-magic-quotes \
        --disable-short-tags \
        --enable-pear \
        --with-apxs=%{Apxs} \
        --enable-bcmath \
        --with-bz2 \
        --without-mod-dav \
        --enable-dba=shared \
        --with-gdbm \
        --with-dbase \
        --with-dom=shared \
        --enable-ftp \
        --with-gd=shared \
        --with-ttf=shared \
        --with-imap=shared \
        --with-java=%{JAVAhome} \
        --with-ldap=shared \
        --with-mysql=shared,/usr \
        --with-mm \
	--with-mcrypt \
        --enable-trans-sid \
        --without-snmp \
        --with-regex=system \
        --enable-xml \
        --with-zlib \
        --enable-versioning \
        --with-tsrm-pthreads \
        --enable-inline-optimization \
        --with-imap-ssl=shared \

make


%Install
%{mkDESTDIR}

# build install directory structure ...
mkdir -p $DESTDIR/usr/lib
mkdir -p $DESTDIR%{ApacheDataDir}/icons
mkdir -p $DESTDIR%{ApacheLibexecDir}
mkdir -p $DESTDIR%{ApacheSysconfDir}

make DESTDIR=$DESTDIR install
install -m 644 php4.gif $DESTDIR%{ApacheDataDir}/icons

# fix up php.ini to auto-load the included modules
PHPINI=$DESTDIR/%{ApacheSysconfDir}/php.ini
install -m 644 php.ini-dist $PHPINI

# hack alert ;)
EXTDIR=`echo $DESTDIR/usr/lib/php/extensions/*| sed s:$DESTDIR::`
%{fixUP} -T $PHPINI -e "s:(extension_dir\s*=)\s*./\s*:\$1 $EXTDIR :"
for i in $DESTDIR$EXTDIR/*; do
  ext=`basename $i`
  %{fixUP} -T $PHPINI -e "s/(;Windows Extensions)/extension=$ext\n\$1/"
done
%{fixUP} -T $PHPINI -e "s/(;Windows Extensions)/\n\n\$1/"

%{fixUP} -T $PHPINI -e \
            's:(mysql.default_socket\s*=):$1 /var/lib/mysql/mysql.sock :'

# install the docs
NV="$DESTDIR/%{_defaultdocdir}/%{Name}-%{Version}"
mkdir -p $NV/{Zend,java,pear}
cp -a CREDITS LICENSE NEWS \
      README.SELF-CONTAINED-EXTENSIONS TODO apidoc.txt apidoc-zend.txt $NV
cp -a Zend/LICENSE Zend/ZEND_CHANGES $NV/Zend
# extensions
cp -a ext/java/README $NV/java
cp -a pear/README $NV/pear

# install the manual
mkdir $NV/manual
tar vxzf %{SOURCE1} -C $NV/manual

%{fixManPages}

# create configuration snippet to be included by httpd.conf
mkdir -p $DESTDIR%{ApacheSysconfDir}/modules
cat <<-EOC > $DESTDIR%{ApacheSysconfDir}/modules/mod_php4.conf
	#
	# mod_php4.conf: included by httpd.conf
	#

	LoadModule php4_module %{ApacheLibexecDir}/libphp4.so
	AddModule  mod_php4.c

	<IfModule mod_php4.c>
	    AddType application/x-httpd-php .php
	    AddType application/x-httpd-php-source .phps
	</IfModule>

EOC


# generate file lists
%{mkLists} -c %{Name}
%{mkLists} -d %{Name} << 'EOF'
%{_defaultdocdir}/%{Name}-%{Version}/manual	doc
%{_defaultdocdir}/%{Name}-%{Version}/		base
/usr/include/php				base
/usr/lib/php					base
.*						IGNORED
@default@
EOF
%{mkLists} -a -f %{Name} << 'EOF'
/usr/bin/pear					IGNORED
%{_defaultdocdir}/%{Name}-%{Version}/manual	doc
mod_php4.conf					base	prefix(%%config)
php.ini						base	prefix(%%config)
.*						base
EOF


%Clean
%{rmDESTDIR}


%Files -f files-%{Name}-base
%defattr(-,root,root)


%Files doc -f files-%{Name}-doc
%defattr(-,root,root)


%ChangeLog
* Mon Jan 01 1998 ...
Template Version: 1.31

$Id: php.spec,v 1.12 2001/09/04 07:59:32 ch Exp $
