%define	   patchlevel pl03

Summary:   Postfix Mail Transport Agent
Name:      postfix
Version:   20010228
Release:   1
URL:       http://www.postfix.org/
Source0:   ftp://postfix.cloud9.net/official/%{Name}-%{Version}-%{patchlevel}.tar.gz
Source1:   postfix.aliases
Source2:   postfix.cron
Source3:   postfix.init
Patch0:    pfixtls-0.7.3-20010228-pl03.diff
Patch1:    postfix-20010228-pfixtls-0.7.3-linux.patch
Patch2:    postfix-20010228-linux.patch
Copyright: IBM Public License
Group:     System/Servers
Provides:  smtpdaemon
Conflicts: sendmail, mtabase
Requires:  openldap, openssl
Prereq:    /usr/bin/wc
Obsoletes: postfix-beta
BuildRoot: %{_tmppath}/%{Name}-%{Version}-root

%Description
Postfix aims to be an alternative to the widely-used sendmail
program.  Sendmail is responsible for 70 percent of all e-mail delivered
on the Internet.  With an estimated 100 million users, that's an
estimated 10 billion (10^10) messages daily. A stunning number.

Although IBM supported the Postfix development, it abstains from
control over its evolution. The goal is to have Postfix installed
on as many systems as possible. To this end, the software is given
away with no strings attached to it, so that it can evolve with
input from and under control by its users.

%Prep
%setup -q -n %{Name}-%{Version}-%{patchlevel}

%patch -P 0 -p1
%patch -P 1 -p1
%patch -P 2 -p1

%Build

# uncomment the next two lines for LDAP support
make tidy
make makefiles CCARGS="-I/usr/include/ -DHAS_LDAP -DHAS_SSL" AUXLIBS="/usr/lib/libldap.a /usr/lib/liblber.a -L /usr/lib/openssl/lib -lssl -lcrypto"
make DEBUG="" OPT="$RPM_OPT_FLAGS"

%Install
%{mkDESTDIR}

install -d $DESTDIR/etc/cron.d/Daily
install -d $DESTDIR/etc/postfix
install -d $DESTDIR%{SVIdir}
install -d $DESTDIR/usr/bin
install -d $DESTDIR%{_libdir}/postfix
install -d $DESTDIR%{_mandir}%{manEN}/man{1,5,8}
install -d $DESTDIR/usr/sbin
install -d $DESTDIR/var/spool/postfix

install -m755 bin/sendmail bin/post* $DESTDIR/usr/sbin
# install -m755 `ls bin/*|egrep -v 'post|fsstone|smtp-|sendmail'` $DESTDIR%{_libdir}/postfix
install -m755 bin/*post* bin/*smtp-* bin/*sendmail* $DESTDIR%{_libdir}/postfix
install -m755 libexec/* $DESTDIR%{_libdir}/postfix
install -m644 conf/access $DESTDIR/etc/postfix
install -m644 conf/canonical $DESTDIR/etc/postfix
install -m644 conf/main.cf $DESTDIR/etc/postfix
install -m644 conf/master.cf $DESTDIR/etc/postfix
install -m755 conf/postfix-script-nosgid $DESTDIR/etc/postfix/postfix-script
install -m644 conf/relocated $DESTDIR/etc/postfix
install -m644 conf/transport $DESTDIR/etc/postfix
install -m644 conf/virtual $DESTDIR/etc/postfix
install -m644 man/man1/* $DESTDIR%{_mandir}%{manEN}/man1
install -m644 man/man5/* $DESTDIR%{_mandir}%{manEN}/man5
install -m644 man/man8/* $DESTDIR%{_mandir}%{manEN}/man8

install -d sample; install -m644 conf/sample* sample

install -m644 %{SOURCE1} $DESTDIR/etc/postfix/aliases
install -m755 %{SOURCE2} $DESTDIR/etc/cron.d/Daily/postfix
install -m755 %{SOURCE3} $DESTDIR%{SVIdir}/postfix

# FIXME - interferes with /etc/aliases from the mtabase package!
# A method by which one /etc/aliases file can be swapped for another should be
# devised when integration with OpenLinux's mta-switch functionality is added.
# Until then, the mtabase package must be included in the Conflicts line in the
# header
ln -sf postfix/aliases $DESTDIR/etc/aliases

# FIXME - when this postfix package is integrated into the mta-switch scheme
# (provided by the mtabase RPM package), this chunk of code should go away.
# The settings that are directed into this file should be handled by the
# /etc/sysconfig/daemons/mta file instead, and should be set using the
# functionality written into the mta-switch scheme
mkdir -p $DESTDIR/etc/sysconfig/daemons
cat <<-'EoD'  > $DESTDIR/etc/sysconfig/daemons/postfix
# Configuration resides in /etc/sysconfig/mouse
IDENT=postfix
DESCRIPTIVE="Postfix Mail Transport Agent"
ONBOOT="yes"
OPTIONS=""
EoD


( cd $DESTDIR/usr/bin
  ln -sf ../sbin/sendmail mailq
  ln -sf ../sbin/sendmail newaliases
)
( cd $DESTDIR/usr/lib
  ln -sf ../sbin/sendmail sendmail
)

for I in etc/postfix/{aliases,access,canonical,relocated,transport,virtual}
do
   touch $DESTDIR/$I{,.db}
done

# set up documentation
docdir=$DESTDIR%{_defaultdocdir}/%{Name}-%{Version}
mkdir -p $docdir
mkdir -p $docdir/{html,examples}
mkdir -p $docdir/examples/{chroot-setup,virtual-setup}
cp {0README,COMPATIBILITY,HISTORY,LICENSE,RELEASE_NOTES,TODO} $docdir
cp html/* $docdir/html
cp examples/chroot-setup/* $docdir/examples/chroot-setup
cp examples/virtual-setup/* $docdir/examples/virtual-setup

%{fixUP} -T $DESTDIR%{SVIdir} -e 's:\@SVIdir\@:%{SVIdir}:'     

%Pre

# stop postfix if already installed and running
if [ -f /var/lock/subsys/postfix ]; then
   %{SVIdir}/postfix stop
fi

# add the group postfix
newGid=40
while [ `grep postfix /etc/group | wc -l` = 0 ] && [ $newGid -lt 100 ]
do
  /usr/sbin/groupadd -g $newGid postfix >/dev/null 2>&1 ||:
  newGid=$((newGid + 1))
done
if [ `grep postfix /etc/group | wc -l` = 0 ]; then 
  echo "Postfix preinstall: Failed to add group postfix"
  exit 1
fi

# add the user postfix
newUid=40
while [ `grep ^postfix: /etc/passwd | wc -l` = 0 ] && [ $newUid -lt 100 ]
do
   /usr/sbin/useradd  -d /var/spool/postfix -s "" \
   -g postfix -c "postfix" -u $newUid postfix ||:
   newUid=$((newUid + 1))
done
if [ `grep ^postfix: /etc/passwd | wc -l` = 0 ]; then 
  echo "Postfix preinstall: Failed to add user postfix"
  exit 1
fi


%Post

# set up alias data
/usr/sbin/postalias /etc/postfix/aliases
ln -sf /etc/postfix/aliases.db /etc/aliases.db

# insert postfix into startup scripts
/usr/lib/LSB/init-install postfix

if [ ! -e %{_libdir}/sendmail ]; then
	ln -sf /usr/sbin/sendmail %{_libdir}/sendmail
fi

/usr/sbin/postfix check >/dev/null 2>&1 ||:


%Preun

if [ $1 = 0 ]; then
   if [ -f /var/lock/subsys/postfix ]; then
      %{SVIdir}/postfix stop
   fi
fi

# remove postfix into startup scripts
/usr/lib/LSB/init-remove postfix

# remove other links
rm -f /etc/aliases.db >/dev/null 2>&1 ||:


%Postun

if [ $1 = 0 ]; then
   if [ `grep postfix /etc/passwd | wc -l` = 1 ]; then
      /usr/sbin/userdel postfix
   fi
   if [ `grep postfix /etc/group | wc -l` = 1 ]; then
      /usr/sbin/groupdel postfix
   fi
   if ! [ -f /var/lock/subsys/postfix ]; then
        rm -rf /var/lock/subsys/postfix
   fi
fi


%Clean
%{rmDESTDIR}

%Files

%defattr(-,root,root)

%{_defaultdocdir}/*

%dir /etc/postfix

%config(noreplace) /etc/cron.d/Daily/postfix
%config(noreplace) %{SVIdir}/postfix
%config(noreplace) /etc/postfix/aliases
%config(noreplace) /etc/postfix/access
%config(noreplace) /etc/postfix/canonical
%config(noreplace) /etc/postfix/main.cf
%config(noreplace) /etc/postfix/master.cf
%config(noreplace) /etc/postfix/relocated
%config(noreplace) /etc/postfix/transport
%config(noreplace) /etc/postfix/virtual
%config(noreplace) /etc/postfix/postfix-script
/usr/bin/*
/usr/sbin/*
/etc/sysconfig/daemons/postfix
#/etc/aliases
/var/spool/postfix
%{_libdir}/postfix
%{_libdir}/sendmail

%attr(-,root,man) %{_mandir}/*/*

%Changelog
* Mon Sep 26 2001 Kurt Hutchison <kurth@caldera.com> 20001212
- udpated the grep for user postfix to be correct
- updated /etc/sysconfig/daemons to be in the file list and
  to remove it an uninstall time, also mod the file itself to remove whitespace
* Mon Feb 19 2001 Andrea Nagao <andrean@sco.com> 20001212
- Updated to postfix version 20001212.   
- New patch postfix-20001212-linux.patch to change master.cf definition
  of cyrus path to /usr/cyrus/bin/deliver.

* Wed Sep 27 2000 Scott Simmons <simmons@sco.com> 19991231_p108-5mdk
- based on postfix-19991231_p108-5mdk.src.rpm from Mandrake
- Removed running of chkconfig for install/uninstall and replaced
  with installing the file /etc/sysconfig/daemons/mta which is
  specific to Caldera. See man mtabase.
- change _initrddir to /etc/postfix/init

* Tue Aug 29 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 19991231_pl08-5mdk
- change license to IBM Public License

* Tue Aug 29 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 19991231_pl08-4mdk
- use noreplace
- use %{_initrddir}

* Tue Aug 29 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 19991231_pl08-3mdk
- correct 2 shell syntax error in %postun

* Wed Aug  2 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 19991231_pl08-2mdk
- %config(noreplace)

* Fri Jul 21 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 19991231_pl08-1mdk
- updated to postfix release 19991231-pl8.
- small specfile cleanup.

* Mon Jul 10 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 19991231-8mdk
- let spechelper compress man-pages and strip binaries (hey guyes, we do this
  for a _long_ time)
- use new macros

* Sat Jul 08 2000 Stefan van der Eijk <s.vandereijk@chello.nl> 19991231-7mdk
- modified find statement to only find files (not directories)
- moved BuildRoot to /var/tmp

* Fri May 05 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 19991231-6mdk
- Fix an aliases.db problem...

* Tue Mar 21 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 19991231-5mdk
- Fix group.

* Wed Mar  8 2000 Pixel <pixel@mandrakesoft.com> 19991231-4mdk
- add prereq wc

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 19991231
- added postfix group
- corrected aliases.db bug

* Mon Dec 27 1999 Jerome Dumonteil <jd@mandrakesoft.com>
- Add postfix check in post to create sub dirs in spool

* Mon Dec 20 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Add -a $DOMAIN -d $LOGNAME to procmail (philippe).
- New banner.

* Wed Nov 10 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- fix if conflicts with sendmail.

* Sat Jun  5 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- install bins from libexec/

* Sat Jun  5 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- 19990601
- .spec cleanup for easier updates

* Wed May 26 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- created link from /usr/sbin/sendmail to %{_libdir}/sendmail
  so it doesn't bug out when i rpm -e sendmail
- Now removes /var/lock/subsys/postfix like a good little prog
  upon rpm -e

* Fri Apr 23 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Mandrake adptations.

* Tue Apr 13 1999 Arne Coucheron <arneco@online.no>
  [19990317-pl04-1]

* Tue Mar 30 1999 Arne Coucheron <arneco@online.no>
  [19990317-pl03-2]
- Castro, Castro, pay attention my friend. You're making it very hard
  maintaining the package if you don't follow the flow of the releases

* Thu Mar 25 1999 Arne Coucheron <arneco@online.no>
  [19990317-pl02-1]

* Tue Mar 23 1999 Arne Coucheron <arneco@online.no>
  [19990317-3]
- added bugfix patch01

* Sat Mar 20 1999 Arne Coucheron <arneco@online.no>
  [19990317-2]
- removed the mynetworks line in main.cf, let postfix figure it out
- striping of the files in /usr/sbin
- alias database moved to /etc/postfix and made a symlink to it in /etc
- enabled procmail support in main.cf and added it to Requires:
- check status on master instead of postfix in the init script
- obsoletes postfix-beta
- had to move some of my latest changelog entries up here since Edgard Castro
  didn't follow my releases

* Thu Mar 18 1999 Edgard Castro <castro@usmatrix.net>
  [19990317]

* Tue Mar 16 1999 Edgard Castro <castro@usmatrix.net>
  [alpha-19990315]

* Tue Mar  9 1999 Edgard Castro <castro@usmatrix.net>
  [19990122-pl01-2]
- shell and gecho information changed to complie with Red Hat stardand
- changed the name of the rpm package to postfix, instead of postfix-beta

* Tue Feb 16 1999 Edgard Castro <castro@usmatrix.net>
  [19990122-pl01-1]

* Sun Jan 24 1999 Arne Coucheron <arneco@online.no>
  [19990122-1]
- shell for postfix user changed to /bin/true to avoid logins to the account
- files in /usr/libexec/postfix moved to %{_libdir}/postfix since this complies
  more with the Red Hat standard

* Wed Jan 06 1999 Arne Coucheron <arneco@online.no>
  [19981230-2]
- added URL for the source
- added a cron job for daily check of errors
- sample config files moved from /etc/postfix/sample to the docdir 
- dropped making of symlinks in /usr/sbin and instead installing the real
  files there
- because of the previous they're not needed anymore in /usr/libexec/postfix,
  so they are removed from that place

* Fri Jan 01 1999 Arne Coucheron <arneco@online.no>
  [19981230-1]

* Tue Dec 29 1998 Arne Coucheron <arneco@online.no>
  [19981222-1]
- first build of rpm version
